Option Strict On
Option Explicit On
'
' $Id: Main.vb 1.7 2014-06-18 13:09:18-04 Ron Exp $ $Name: release1dot7 $
'
Module Test_Main
	'''______________________________________________________________________________
	''' Test mt19937-64.vb by testing as the original authors did in
	''' mt19937-64test.c.  Also produce demo output and data for further
	''' testing.
	'''______________________________________________________________________________
	''' 
	Function Main() As Integer	 'int main(void)
		Dim i As Integer
		Dim init64() As ULong = {&H12345UL, &H23456UL, &H34567UL, &H45678UL}
		' We don't need length.

		Const fileName As String = "mt19937-64VBTest.out.txt"
		Const mebibyte As Integer = 1048576
		Const count As Integer = 1000 - 1
		Dim ulng As ULong
		Dim s As String

		Try
			Dim r As New MTRandom64(init64)

			FileOpen(1, fileName, OpenMode.Output)	   'open the output file

			' To prevent alignment on tab columns, SPC() is required.
			PrintLine(1, (count + 1).ToString, SPC(1), "outputs of genrand64_int64()")

			For i = 0 To count
				ulng = r.genrand64_int64()

				' A space character is required at the end of the line to match the
				' original MT authors' test output.
				Print(1, String.Format("{0,20} ", ulng))	' no line ending
				If i Mod 5 = 4 Then
					PrintLine(1)	' line ending
				End If
			Next

			PrintLine(1)

			' To prevent alignment on tab columns, SPC() is required.
			PrintLine(1, (count + 1).ToString(), SPC(1), "outputs of genrand64_real2()")

			For i = 0 To count
				s = Strings.Format(r.genrand64_real2(), "0.00000000")
				' Uncomment the following "s =..." line if you need to force a decimal
				' point instead of a decimal comma (if needed for locale).  Decimal
				' points are used in the original authors' mt19937-64.out.txt file.
				's = Strings.Replace(s, ",", ".")

				' A space character is required at the end of the line to match the
				' original MT authors' test output.
				Print(1, s, SPC(1))	' no line ending
				If i Mod 5 = 4 Then
					PrintLine(1)	' line ending
				End If
			Next
			FileClose(1)	'close the output file

			Console.WriteLine("MT test output was written to file '{0}'.", fileName)

			' The following were added by Ron Charlton, and are not a part
			' of the original mt19937-64.c authors' Main().

			' Produce a file of random bytes for testing with John Walker's entropy
			' test program, ent.exe (at http://www.fourmilab.ch/random/).
			MakeEntropyTestData64()

			' Produce a file of random 64-bit integers for testing with George Marsaglia's
			' Diehard test program, DIEHARD.EXE (at http://www.stat.fsu.edu/pub/diehard/).
			MakeDiehardData64()

			' Demonstrate the MTRandom64 class. (It writes to file Demo64.out.txt and the
			' console.)
			Demo64()

			' Test the CryptoRNGServiceProvider PRNG via MTRandom64.init_by_crypto64(0.0).
			' Create 100 sequences for NIST's Statistical Test Suite's assess.exe.
			Test_init_by_crypto64(mebibyte * 100)

			' Run a performance test.
			PerformanceTest64()

		Catch ex As Exception
			Console.Error.WriteLine("{0}: {1}", _
			 My.Application.Info.AssemblyName, ex.Message)
			Console.Error.WriteLine("{0}", ex.StackTrace)
			' Prevent the window from closing in the Visual Basic .NET IDE.
			Console.Error.WriteLine("Press the <Enter> key to quit.")
			Console.ReadLine()
			Return 1
		End Try

		Return 0
	End Function   'main

End Module
